<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "scan_result".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ScanResult".
 *
 * Columns in table "scan_result" available as properties of the model,
 * followed by relations of table "scan_result" available as properties of the model.
 *
 * @property integer $id
 * @property integer $scan_id
 * @property integer $error
 * @property integer $match_name
 * @property integer $match_address
 * @property integer $match_phone
 * @property string $code
 * @property string $url
 * @property string $scraped_name
 * @property string $scraped_address
 * @property string $scraped_phone
 * @property string $date_added
 *
 * @property Scan $scan
 */
abstract class BaseScanResult extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'scan_result';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ScanResult|ScanResults', $n);
    }

    public static function representingColumn()
    {
        return 'code';
    }

    public function rules()
    {
        return array(
            array('scan_id, code', 'required'),
            array('scan_id, error, match_name, match_address, match_phone', 'numerical', 'integerOnly' => true),
            array('code', 'length', 'max' => 25),
            array('scraped_name, scraped_address', 'length', 'max' => 255),
            array('scraped_phone', 'length', 'max' => 32),
            array('url, date_added', 'safe'),
            array('error, match_name, match_address, match_phone, url, scraped_name, scraped_address, scraped_phone, date_added', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, scan_id, error, match_name, match_address, match_phone, code, url, scraped_name, scraped_address, scraped_phone, date_added', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'scan' => array(self::BELONGS_TO, 'Scan', 'scan_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'scan_id' => null,
            'error' => Yii::t('app', 'Error'),
            'match_name' => Yii::t('app', 'Match Name'),
            'match_address' => Yii::t('app', 'Match Address'),
            'match_phone' => Yii::t('app', 'Match Phone'),
            'code' => Yii::t('app', 'Code'),
            'url' => Yii::t('app', 'Url'),
            'scraped_name' => Yii::t('app', 'Scraped Name'),
            'scraped_address' => Yii::t('app', 'Scraped Address'),
            'scraped_phone' => Yii::t('app', 'Scraped Phone'),
            'date_added' => Yii::t('app', 'Date Added'),
            'scan' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('scan_id', $this->scan_id);
        $criteria->compare('error', $this->error);
        $criteria->compare('match_name', $this->match_name);
        $criteria->compare('match_address', $this->match_address);
        $criteria->compare('match_phone', $this->match_phone);
        $criteria->compare('code', $this->code, true);
        $criteria->compare('url', $this->url, true);
        $criteria->compare('scraped_name', $this->scraped_name, true);
        $criteria->compare('scraped_address', $this->scraped_address, true);
        $criteria->compare('scraped_phone', $this->scraped_phone, true);
        $criteria->compare('date_added', $this->date_added, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
